#ifndef _IRLAP_H_
#define _IRLAP_H_

struct irlap_conn_data {
	u_int8_t		rate;
	u_int8_t		maxturn;
	u_int8_t		datasize;
	u_int8_t		winsize;
	u_int8_t		nbof;
	u_int8_t		minturn;
	u_int8_t		thresh;
};

struct irlap_state {
	u_int8_t		is_state;
	u_int32_t		is_address;
	u_int32_t		is_remote;
	u_int8_t		is_connection;
	int			is_csp;
	int			is_dsp;
	struct sockaddr_ng	is_sng;
	u_int8_t		is_xid_slot;
	struct irlap_conn_data	is_conn_params;
};

enum {
	IRLAP_STATE_NDM = 1,
	IRLAP_STATE_QUERY,
	IRLAP_STATE_REPLY,
	IRLAP_STATE_CONN,
	IRLAP_STATE_SETUP,
	IRLAP_STATE_NRM_P,
	IRLAP_STATE_NRM_S,
};

#define IRLAP_MASK_CR 0x01
#define IRLAP_MASK_PF 0x10
#define IRLAP_BROADCAST 0xfe

struct irlap_frame {
	u_int8_t	ifr_connection;
	u_int8_t	ifr_control;
	char		ifr_data[0];
#define ifr_command ifr_address&IRLAP_MASK_CR
#define ifr_poll ifr_control&IRLAP_MASK_PF
#define ifr_final ifr_control&IRLAP_MASK_PF
};

#define IRLAP_COMMAND_SNRM	0x83
#define IRLAP_COMMAND_DISC	0x43
#define IRLAP_COMMAND_UI	0x03
#define IRLAP_COMMAND_XID	0x2f
#define IRLAP_COMMAND_TEST	0xe3

#define IRLAP_RESPONSE_RNRM	0x83
#define IRLAP_RESPONSE_UA	0x63
#define IRLAP_RESPONSE_FRMR	0x87
#define IRLAP_RESPONSE_DM	0x0f
#define IRLAP_RESPONSE_UI	0x03
#define IRLAP_RESPONSE_XID	0xaf
#define IRLAP_RESPONSE_TEST	0xe3

#define IRLAP_SUPERVISORY_RR	0x01
#define IRLAP_SUPERVISORY_RNR	0x05
#define IRLAP_SUPERVISORY_REJ	0x09
#define IRLAP_SUPERVISORY_SREJ	0x0d

#define IRLAP_PARAM_RATE	0x01
#define IRLAP_PARAM_MAXTURN	0x82
#define IRLAP_PARAM_DATASIZE	0x83
#define IRLAP_PARAM_WINSIZE	0x84
#define IRLAP_PARAM_NBOF	0x85
#define IRLAP_PARAM_MINTURN	0x86
#define IRLAP_PARAM_THRESH	0x08

struct xid_frame {
	u_int32_t	xid_source;
	u_int32_t	xid_destination;
	u_int8_t	xid_flags;
	u_int8_t	xid_slot;
	u_int8_t	xid_version;
	u_int8_t	xid_data[0];
};

struct test_frame {
	u_int32_t	test_source;
	u_int32_t	test_destination;
	char		test_data[0];
};

struct snrm_frame {
	u_int32_t	snrm_source;
	u_int32_t	snrm_destination;
	u_int8_t	snrm_connection;
	char		snrm_data[0];
};

struct ua_frame {
	u_int32_t	ua_source;
	u_int32_t	ua_destination;
	char		ua_data[0];
};

struct frmr_frame {
	u_int8_t	ua_control;
	u_int8_t	ua_data[2];
};

#endif /* _IRLAP_H_ */
